// unit D_caretmemo
//
// additional memo control that supports custom carets and with
// some other functions that borland forgot
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit D_caretmemo;

interface

uses
  Windows, Graphics, Classes, Controls, Forms, SysUtils,
  StdCtrls, Menus, messages;

type
  TD_caretmemo = class(tmemo)
  private
    FAlignment : TAlignment;
    Bmp: TBitmap;
    fflat:boolean;
    FHideScrollBars: Boolean;
    procedure SetBmp(Value: TBitmap);
    procedure Setflat(Value: boolean);
    procedure SetHideScrollBars(Value: Boolean);
    procedure CMEnter(var message:TCMGotFocus);message CM_ENTER;
    procedure WM_SETFOCUS(var message:TWMSetFocus);message WM_SETFOCUS;
    procedure WM_KILLFOCUS(var message:TWMKillFocus);message WM_KILLFOCUS;
    procedure caret;
  protected
    procedure CreateParams(var Params:TCreateParams); override;
    procedure SetAlignment(NewValue:TAlignment);
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    procedure Loaded; override;
    constructor Create(AOwner:TComponent); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: char); override;
    published
    property HideScrollBars: Boolean read FHideScrollBars write SetHideScrollBars default True;
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property Align;
    property input_caret: TBitmap read Bmp write SetBmp;
    property flat: boolean read fflat write Setflat;
    property OnKeydown;
    property OnKeyUp;
    property OnKeypress;
    property OnMouseDown;
    property OnMouseUp;

    property anchors;

  end;

procedure Register;

implementation

procedure tD_caretmemo.SetBmp(Value: TBitmap);
begin
Bmp.Assign(value);
caret;         /////////
RecreateWnd;
end;

procedure tD_caretmemo.Setflat(Value: boolean);
begin
fflat:=value;
RecreateWnd;
end;

procedure tD_caretmemo.caret;
begin
if bmp.empty = false then begin
CreateCaret(self.Handle, Bmp.Handle, 0, 0);
ShowCaret(self.Handle);
end;
invalidate;
end;

procedure tD_caretmemo.KeyDown(var Key: Word; Shift: TShiftState);
begin
inherited;
end;

procedure tD_caretmemo.KeyUp(var Key: Word; Shift: TShiftState);
begin
inherited;
end;

procedure tD_caretmemo.KeyPress(var Key: char);
begin
inherited;
end;

procedure tD_caretmemo.WM_SETFOCUS(var message:TWMSetFocus);
begin
inherited;
caret;         /////////
end;

procedure tD_caretmemo.WM_KILLFOCUS(var message:TWMKillFocus);
begin
inherited;
HideCaret(self.handle);
DestroyCaret;
end;

procedure tD_caretmemo.CMEnter(var message:TCMGotFocus);
begin
inherited;
end;

procedure tD_caretmemo.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
inherited;
end;

procedure tD_caretmemo.MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
inherited;
end;

procedure TD_caretmemo.Loaded;
begin
inherited;
end;

Constructor TD_caretmemo.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
bmp:=tbitmap.Create;
end;

procedure TD_caretmemo.SetHideScrollBars(Value: Boolean);
begin
  if HideScrollBars <> Value then
  begin
    FHideScrollBars := value;
    RecreateWnd;
  end;
end;

procedure TD_caretmemo.CreateParams(var Params: TCreateParams);
const
ES_DISABLENOSCROLL = $00002000;
HideScrollBars: array[Boolean] of DWORD = (ES_DISABLENOSCROLL, 0);
begin
inherited CreateParams(Params);
case Alignment of
taLeftJustify  : Params.Style := Params.Style or ES_LEFT;
taRightJustify : Params.Style := Params.Style or ES_RIGHT;
taCenter       : Params.Style := Params.Style or ES_CENTER;
end;
if fflat=true then params.ExStyle:=params.ExStyle OR ws_ex_staticedge;
if fflat=false then params.ExStyle:=params.ExStyle and not ws_ex_staticedge;

  with Params do
  begin
    Style := Style or HideScrollBars[FHideScrollBars];
  end;

end;

procedure TD_caretmemo.SetAlignment(NewValue:TAlignment);
begin
if FAlignment<>NewValue then begin
FAlignment:=NewValue;
RecreateWnd;
end;
end;

procedure Register;
begin
RegisterComponents('Delfi', [TD_caretmemo]);
end;

end.
