// unit Delfi_Form_client_mover
//
// a utility component for forms : can hide application from ctrl+alt+del,
// can make form movable if you click on it's client and it can flash window
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_Form_client_mover;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TDelfi_Form_client_mover = class(TComponent)
  private
    { Private declarations }
    ParentForm: TForm;
    FMoveable: Boolean;
    Fnot_on_ctrl_alt_delete_: Boolean;
    PrevParentWndProc: Pointer;
    procedure setnot_on_ctrl_alt_delete_(value: boolean);
    procedure NewParentWndProc(var Msg: TMessage);
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure flashicon(value:boolean);
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Moveable: Boolean read FMoveable write FMoveable;
    property not_on_ctrl_alt_delete_: Boolean read Fnot_on_ctrl_alt_delete_ write setnot_on_ctrl_alt_delete_;
  end;

procedure Register;

function RegisterServiceProcess(dwProcessID, dwType: Integer): Integer; stdcall; external 'KERNEL32.DLL';

implementation

procedure TDelfi_Form_client_mover.setnot_on_ctrl_alt_delete_(value:boolean);
begin
Fnot_on_ctrl_alt_delete_:=value;
if not (csDesigning in ComponentState) then begin
if value = false then RegisterServiceProcess(GetCurrentProcessID, 0);
if value = true then RegisterServiceProcess(GetCurrentProcessID, 1);
end;
end;

procedure TDelfi_Form_client_mover.flashicon(value:boolean);
begin
flashwindow(application.handle,value);
end;

constructor TDelfi_Form_client_mover.Create(aOwner: TComponent);
var p: Pointer;
begin
inherited Create(aOwner);
Fnot_on_ctrl_alt_delete_:=false;
FMoveable := True;
ParentForm := TForm(aOwner);
// this is the only way to trap messages of parent form
PrevParentWndProc := Pointer(GetWindowLong(ParentForm.Handle, GWL_WNDPROC));
p := MakeObjectInstance(NewParentWndProc);
SetWindowLong(ParentForm.Handle, GWL_WNDPROC, LongInt(p));
end;

destructor TDelfi_Form_client_mover.Destroy;
begin
if ParentForm.HandleAllocated then
SetWindowLong(ParentForm.Handle, GWL_WNDPROC, LongInt(PrevParentWndProc));
inherited Destroy;
end;

procedure TDelfi_Form_client_mover.NewParentWndProc(var Msg: TMessage);
begin
// let's play with the messages !
Msg.Result := CallWindowProc(PrevParentWndProc, ParentForm.Handle, Msg.Msg,Msg.WParam, Msg.LParam);
if not (csDesigning in ComponentState) then begin
if FMoveable = true then if Msg.Msg =  wm_NCHitTest then if Msg.Result = htClient then Msg.Result := htCaption;
end;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_Form_client_mover]);
end;

end.
 
