// unit Delfi_ListBox
//
// listbox that can display images from imagelist
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_ListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDelfi_ListBox = class(TcustomListBox)
  private
    { Private declarations }
    fimagelist:timagelist;
    fspace:integer;
    fflat:boolean;
    procedure Setflat(Value: boolean);
    procedure setimagelist(Value: timagelist);
    procedure setspace(Value: integer);
  protected
    { Protected declarations }
    Bitmap: TBitmap;
    procedure CreateParams(var Params:TCreateParams); override;
    procedure DrawItem(Control: TWinControl; Index: Integer;
    Rect: TRect; State: TOwnerDrawState);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property imagelist : timagelist read fimagelist write setimagelist;
    property space : integer read fspace write setspace;
    property flat: boolean read fflat write Setflat;
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderStyle;
    property Color;
    property Columns;
    property Constraints;
    property Ctl3D;
    property Cursor;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property HelpContext;
    property Hint;
    property ImeMode;
    property ImeName;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property MultiSelect;
    property Name;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property TabWidth;
    property Tag;
    property Visible;

    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
//    property OnMeasureItem;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
end;

procedure Register;

implementation

procedure TDelfi_ListBox.Setflat(Value: boolean);
begin
fflat:=value;
RecreateWnd;
end;

procedure TDelfi_ListBox.setimagelist(Value: timagelist);
begin
fimagelist:=Value;
invalidate;
end;

procedure TDelfi_ListBox.setspace(Value: integer);
begin
fspace:=Value;
invalidate;
end;

procedure TDelfi_ListBox.CreateParams(var Params: TCreateParams);
begin
inherited CreateParams(Params);
if fflat=true then params.ExStyle:=params.ExStyle OR ws_ex_staticedge;
if fflat=false then params.ExStyle:=params.ExStyle and not ws_ex_staticedge;
end;

procedure TDelfi_ListBox.DrawItem(Control: TWinControl; Index: Integer;
Rect: TRect; State: TOwnerDrawState);
var Offset: Integer;
begin
try
with (Control as TcustomListBox).Canvas do
begin
FillRect(Rect);
Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);

//pen.Color:=clwhite;
//brush.Color:=clwhite;
//Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);

if fimagelist <> nil then begin
fImageList.GetBitmap(index,Bitmap);
FillRect(Rect);
BrushCopy(Bounds(Rect.Left + 2, Rect.Top, Bitmap.Width, Bitmap.Height),
Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), Bitmap.Canvas.Pixels[0,0]);
Offset := Bitmap.width + fspace;

//font.Assign(self.Font);
self.ItemHeight:= Bitmap.Height;

TextOut(Rect.Left + Offset, Rect.Top, (Control as TcustomListBox).Items[Index])
end;
if fimagelist = nil then begin
FillRect(Rect);
self.ItemHeight:= 4 - textheight((Control as TcustomListBox).Items[Index]);
TextOut(Rect.Left + fspace, Rect.Top, (Control as TcustomListBox).Items[Index])
end;
end;
except end;
end;

constructor TDelfi_ListBox.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
fspace:=7;
Font.Name := 'Arial';
Font.Color := clblack;
Font.Size := 7;
ShowHint := true;
TabStop := True;
style:=lbOwnerDrawFixed;
OnDrawItem:=DrawItem;
itemheight:=17;
Bitmap := TBitmap.Create;
end;

destructor TDelfi_ListBox.Destroy;
begin
inherited Destroy;
Bitmap.FreeImage;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_ListBox]);
end;

end.
