// unit Delfi_progressbar
//
// additional progressbar with properties : ElementColor, color
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_progressbar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, commctrl;

type
  TOrientation = (pbHorizontal,pbVertical);
  TDelfi_progressbar = class(TProgressBar)
  private
    { Private declarations }
  FOrientation:TOrientation;
  FElementColor:tcolor;
  FColor:tcolor;
  procedure SetElementColor(color_:tcolor);
  procedure SetColor(color_:tcolor);
  procedure WMEraseBkGnd(var message_: TWMEraseBkGnd); message WM_ERASEBKGND;
  procedure SetOrientation(value:TOrientation);
  protected
    { Protected declarations }
  procedure CreateParams(var Params:TCreateParams); override;
  public
    { Public declarations }
  constructor Create(aOwner:TComponent); override;
  published
    { Published declarations }
  property ElementColor:tColor read FElementColor write SetElementColor;
  property color:tColor read FColor write SetColor;
  property Orientation:TOrientation read FOrientation write SetOrientation;
  end;

procedure Register;

implementation

procedure TDelfi_progressbar.SetOrientation(value:TOrientation);
var position_:integer;
begin
{prevwidth:=self.width;
prevheight:=self.height;}
position_:=self.position;
FOrientation:=value;

recreatewnd;

color:=Fcolor;
ElementColor:=FElementColor;

//Width:=prevheight;
//Height:=prevwidth;
position:=position_;
end;

procedure TDelfi_progressbar.CreateParams(var Params:TCreateParams);
begin
inherited CreateParams(params);
if FOrientation=pbVertical then
params.style:=params.style AND NOT $04
else
params.style:=params.style OR $04;
end;

constructor TDelfi_progressbar.Create(aOwner: TComponent);
begin
inherited;
FElementColor:=clHighLight;
Fcolor:=clbtnface;
end;

procedure TDelfi_progressbar.SetElementColor(color_:tcolor);
begin
sendmessage(self.handle,$0409,0,longint(colortorgb(color_)));
FElementColor:=color_;
end;

procedure TDelfi_progressbar.SetColor(color_:tcolor);
begin
inherited;
Fcolor:=color_;
end;

// this changes the background it could work on some other controls too !!!
procedure TDelfi_progressbar.WMEraseBkGnd(var message_: TWMEraseBkGnd);
var tempbrush: HBRUSH;
begin
message_.Result := 1;
tempbrush := CreateSolidBrush(ColorToRGB(FColor));
FillRect(message_.DC, ClientRect, tempbrush);
DeleteObject(tempbrush);
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_progressbar]);
end;

end.
