// unit Delfi_checkbox
//
// additional checkbox that looks like i want !
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_checkbox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDelfi_checkbox = class(TcustomControl)
  private
    caption_ : string;
    focused___:boolean;
    fchecked:boolean;
    fEnabled:boolean;
    drawfocusrect_:boolean;
    _color_light : TColor;
    _color_shadow : TColor;
    MDown: TMouseEvent;
    MUp: TMouseEvent;
    BtnClick: TNotifyEvent;
    procedure setdrawfocusrect(Value: boolean);
    procedure setchecked(Value: boolean);
    procedure setEnabled(Value: boolean);
    procedure SetCap(Value: string);
    procedure set_color_light(Value: TColor);
    procedure set_color_shadow(Value: TColor);
    procedure WMSETFOCUS (var message: TMessage); message  WM_SETFOCUS;
    procedure WMKILLFOCUS (var message: TMessage); message WM_KILLFOCUS;
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Click; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: char); override;
    procedure SetParent(Value: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Align;
    property DrawFocusrect : boolean read drawfocusrect_ write Setdrawfocusrect;
    property checked : boolean read fchecked write setchecked;
    property Enabled : boolean read fEnabled write setEnabled;
    property Caption : string read Caption_ write SetCap;
    property OnMouseDown: TMouseEvent read MDown write MDown;
    property OnMouseUp: TMouseEvent read MUp write MUp;
    property OnClick: TNotifyEvent read BtnClick write BtnClick;
    property color_light : TColor read _color_light write set_color_light default clwhite ;
    property color_shadow : TColor read _color_shadow write set_color_shadow default clgray ;
    property OnMouseMove;
    property Font;
    property ShowHint;
    property ParentShowHint;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnExit;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property TabOrder;
    property TabStop;
    property OnstartDock;
    property OnstartDrag;
    property Visible;
    property Popupmenu;
    property helpcontext;
    property cursor;
    property dragkind;
    property dragmode;
    property dragcursor;
  end;

procedure Register;

implementation

constructor TDelfi_checkbox.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
controlstyle:=controlstyle + [csOpaque];
Width := 80;
Height := 13;
Font.Name := 'Arial';
Font.Color := clblack;
Font.Size := 8;
fEnabled := true;
ShowHint := true;
TabStop := True;
_color_shadow:=clgray;
_color_light:=clwhite;
end;

procedure TDelfi_checkbox.SetParent(Value: TWinControl);
begin
inherited;
if csdesigning in componentstate then if Value <> nil then Caption_ := Name;
end;

procedure TDelfi_checkbox.Paint;
var TextHeight : Longint;
Frame:TRect;
toppainter : integer;
begin
inherited Paint;
Canvas.Brush.Color := clbtnface;
Canvas.FillRect(Canvas.ClipRect);

toppainter:=height div 2 - 6;
try

except end;

Canvas.Font := Font;
Canvas.Brush.Color := clbtnface;

TextHeight := Canvas.TextHeight(Caption_);
Canvas.Font.Color := Font.Color;

if fenabled = true then Canvas.Brush.Color := clwhite;
if fenabled = false then Canvas.Brush.Color := clbtnface;

Frame := GetClientRect;
Frame := Rect(0,toppainter+0,13,toppainter+13);

Canvas.FillRect(Frame);

canvas.pen.Color:=_color_shadow;
canvas.MoveTo(0,toppainter+0);
canvas.lineto(13,toppainter+0);
canvas.MoveTo(0,toppainter+0);
canvas.lineto(0,toppainter+13);

canvas.pen.Color:=clbtnface;
canvas.Rectangle (1, toppainter+1, 12, toppainter+12);


canvas.pen.Color:=_color_light;
canvas.MoveTo(1,toppainter+12);
canvas.lineto(12,toppainter+12);
canvas.lineto(12,toppainter);


if fchecked = true then begin
if fenabled = true then canvas.pen.Color:=clblack;
if fenabled = false then canvas.pen.Color:=clgray;
canvas.MoveTo(3,toppainter+5);
canvas.lineto(5,toppainter+7);
canvas.lineto(9,toppainter+3);
canvas.lineto(9,toppainter+5);
canvas.lineto(5,toppainter+9);
canvas.lineto(3,toppainter+7);
canvas.lineto(3,toppainter+5);
canvas.MoveTo(4,toppainter+7);
canvas.lineto(5,toppainter+8);
canvas.lineto(9,toppainter+4);
end;

Canvas.Brush.Color := clbtnface;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(17,Height div 2-TextHeight div 2,Caption_);

if fEnabled = true then begin
if drawfocusrect_ then begin
if focused___ then begin
Frame := Rect(1,1,12,12);
Canvas.DrawFocusRect(Frame);
end;
end;
end;
end;

procedure TDelfi_checkbox.Click;
begin
inherited Click;
if fenabled = true then fchecked := not fchecked;
if fenabled then if Assigned(BtnClick) then BtnClick(Self);
Paint;
end;

procedure TDelfi_checkbox.Setdrawfocusrect(Value: boolean);
begin
drawfocusrect_ := Value;
Paint;
end;

procedure TDelfi_checkbox.setchecked(Value: boolean);
begin
fchecked := Value;
Paint;
end;

procedure TDelfi_checkbox.setEnabled(Value: boolean);
begin
fenabled := Value;
Paint;
end;

procedure TDelfi_checkbox.SetCap(Value: string);
begin
Caption_ := value;
Paint;

end;

procedure TDelfi_checkbox.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
inherited MouseDown(Button, Shift, X, Y);
SetFocus;
paint;
end;

procedure TDelfi_checkbox.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
inherited MouseUp(Button, Shift, X, Y);
Paint;
end;

procedure TDelfi_checkbox.KeyDown(var Key: Word; Shift: TShiftState);
begin
inherited keydown(key,shift);
If (Key = VK_SPACE) then if fenabled = true then begin
fchecked := not fchecked;
if fenabled then if Assigned(BtnClick) then BtnClick(Self);
end;
paint;
end;

procedure TDelfi_checkbox.KeyUp(var Key: Word; Shift: TShiftState);
begin
inherited keyup(key,shift);
Paint;
end;

procedure TDelfi_checkbox.KeyPress(var Key: char);
begin
inherited keypress(key);
Paint;
end;

procedure TDelfi_checkbox.WMSETFOCUS (var message: TMessage);
begin
Focused___ := true;
Paint;
end;

procedure TDelfi_checkbox.WMKILLFOCUS (var message: TMessage);
begin
Focused___ := false;
Paint;
end;

procedure TDelfi_checkbox.set_color_light(Value: TColor);
begin
_color_light := Value;
Paint;
end;

procedure TDelfi_checkbox.set_color_shadow(Value: TColor);
begin
_color_shadow := Value;
Paint;
end;

procedure Register;
begin
RegisterComponents('Delfi', [tDelfi_checkbox]);
end;

end.
