// Delfi_dragdrop
//
// drag'n drop support for your application
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_dragdrop;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, controls, Forms, Dialogs,
  shellapi;

type
  tfilesdropped = procedure(numitems:integer;list:tstringlist) of object;
  TDelfi_dragdrop = class(TComponent)
  private
    { Private declarations }
    ffilesdropped:tfilesdropped;
    oldwndproc : tfarproc;
    newwndproc : pointer;
    factive:boolean;
    procedure hookparent;
    procedure unhookparent;
    procedure hookwndproc(var message: tmessage);
    procedure setactive(value:boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor create(aowner:tcomponent); override;
    destructor  destroy; override;
  published
    { Published declarations }
    property active:boolean read factive write setactive;
    property onfilesdropped:tfilesdropped read ffilesdropped write ffilesdropped;
  end;

var flist:tstringlist;

procedure Register;

implementation

constructor TDelfi_dragdrop.create(aowner:tcomponent);
begin
inherited create(aowner);
newwndproc := nil;
oldwndproc := nil;
flist := tstringlist.create;
if componentstate<>[csdesigning] then
begin
hookparent;
setactive(factive);
end;
end;

destructor TDelfi_dragdrop.destroy;
begin
unhookparent;
flist.free;
inherited destroy;
end;

procedure TDelfi_dragdrop.hookparent;
begin
if (owner as twincontrol) = nil then exit;
oldwndproc := tfarproc(getwindowlong((owner as twincontrol).handle, gwl_wndproc));
newwndproc := makeobjectinstance(hookwndproc);
setwindowlong((owner as twincontrol).handle, gwl_wndproc, longint(newwndproc));
end;

procedure TDelfi_dragdrop.unhookparent;
begin
if ( (owner as twincontrol)<> nil) and (assigned(oldwndproc) ) then
setwindowlong((owner as twincontrol).handle, gwl_wndproc, longint(oldwndproc));
if assigned(newwndproc) then
freeobjectinstance(newwndproc);
newwndproc := nil;
oldwndproc := nil;
end;

procedure TDelfi_dragdrop.hookwndproc(var message: tmessage);
const
cnmaxfilenamelen = 255;
var i,nl,nfiles:integer;
fname:array[1..255] of char;
begin
if (owner as twincontrol) = nil then
exit;
with message do
begin
result := callwindowproc(oldwndproc, (owner as twincontrol).handle, msg, wparam, lparam);
if (msg = wm_dropfiles) then
begin
flist.clear;
nfiles := dragqueryfile(message.wparam,$ffffffff,'',cnmaxfilenamelen );
for i:=0 to nfiles-1 do
begin
nl := dragqueryfile(wparam,i,@fname,255)+1;
fname[nl] := #0;
flist.add(fname);
end;
if ((nfiles>0) and (assigned(ffilesdropped))) then
ffilesdropped(nfiles,flist);
end;
end;
end;

procedure TDelfi_dragdrop.setactive(value:boolean);
begin
factive := value;
if componentstate <> [csdesigning] then dragacceptfiles((owner as twincontrol).handle,factive);
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_dragdrop]);
end;

end.
