// unit Delfi_edit
//
// additional edit control with text alignment left center right
// it supports custom carets too !
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_edit;

interface

uses
  Windows, Graphics, Classes, Controls, Forms, SysUtils,
  StdCtrls, Menus, messages;

type
  TDelfi_edit = class(TEdit)
  private
    FAlignment : TAlignment;
    Bmp: TBitmap;
    fflat:boolean;
    procedure SetBmp(Value: TBitmap);
    procedure Setflat(Value: boolean);
    procedure CMEnter(var message:TCMGotFocus);message CM_ENTER;
    procedure WM_SETFOCUS(var message:TWMSetFocus);message WM_SETFOCUS;
    procedure WM_KILLFOCUS(var message:TWMKillFocus);message WM_KILLFOCUS;
    procedure caret;
  protected
    procedure CreateParams(var Params:TCreateParams); override;
    procedure SetAlignment(NewValue:TAlignment);
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    procedure Loaded; override;
    constructor Create(AOwner:TComponent); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: char); override;
    published
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property Align;
    property input_caret: TBitmap read Bmp write SetBmp;
    property flat: boolean read fflat write Setflat;
    property OnKeydown;
    property OnKeyUp;
    property OnKeypress;
    property OnMouseDown;
    property OnMouseUp;

    property anchors;

  end;

procedure Register;

implementation

procedure tDelfi_edit.SetBmp(Value: TBitmap);
begin
Bmp.Assign(value);
caret;         /////////
RecreateWnd;
end;

procedure tDelfi_edit.Setflat(Value: boolean);
begin
fflat:=value;
RecreateWnd;
end;

procedure tDelfi_edit.caret;
begin
if bmp.empty = false then begin
CreateCaret(self.Handle, Bmp.Handle, 0, 0);
ShowCaret(self.Handle);
end;
invalidate;
end;

procedure tDelfi_edit.KeyDown(var Key: Word; Shift: TShiftState);
begin
inherited;
end;

procedure tDelfi_edit.KeyUp(var Key: Word; Shift: TShiftState);
begin
inherited;
end;

procedure tDelfi_edit.KeyPress(var Key: char);
begin
inherited;
end;

procedure tDelfi_edit.WM_SETFOCUS(var message:TWMSetFocus);
begin
inherited;
caret;         /////////
end;

procedure tDelfi_edit.WM_KILLFOCUS(var message:TWMKillFocus);
begin
inherited;
HideCaret(self.handle);
DestroyCaret;
end;

procedure tDelfi_edit.CMEnter(var message:TCMGotFocus);
begin
inherited;
end;

procedure tDelfi_edit.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
inherited;
end;

procedure tDelfi_edit.MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
inherited;
end;

procedure TDelfi_edit.Loaded;
begin
inherited;
end;

Constructor TDelfi_edit.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
bmp:=tbitmap.Create;
end;

procedure TDelfi_edit.CreateParams(var Params: TCreateParams);
begin
inherited CreateParams(Params);
case Alignment of
taLeftJustify  : Params.Style := Params.Style or ES_LEFT;
taRightJustify : Params.Style := Params.Style or ES_RIGHT;
taCenter       : Params.Style := Params.Style or ES_CENTER;
end;
if fflat=true then params.ExStyle:=params.ExStyle OR ws_ex_staticedge;
if fflat=false then params.ExStyle:=params.ExStyle and not ws_ex_staticedge;
end;

procedure TDelfi_edit.SetAlignment(NewValue:TAlignment);
begin
if FAlignment<>NewValue then begin
FAlignment:=NewValue;
RecreateWnd;
end;
end;

procedure Register;
begin
RegisterComponents('Delfi', [TDelfi_edit]);
end;

end.
