// unit Delfi_integerselector
//
// an component for selecting integer values
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_integerselector;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, Delfi_edit;

type
  TOrientation = (pbHorizontal,pbVertical);
  TDelfi_integerselector = class(TCustomPanel)
  procedure Edit_Change(Sender: TObject);
  procedure Edit_KeyPress(Sender: TObject; var Key: Char);
  procedure Edit_Keydown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure posbarChange(Sender: TObject);

  private
    { Private declarations }
    color_:tcolor;
    fvalue:integer;
    flength:integer;
    fmax:integer;
    fmin:integer;
    FOrientation:TOrientation;
    fonchange : TNotifyEvent;
    procedure SetCol(Value: TColor);
    procedure Setvalue(Value: integer);
    procedure Setlength(Value: integer);
    procedure Setmin(Value: integer);
    procedure Setmax(Value: integer);
    procedure SetOrientation(value:TOrientation);
  protected
    { Protected declarations }
  edit_:tDelfi_edit;
  posbar:tscrollbar;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Loaded; override;
  published
    { Published declarations }
    property Align;
    property value : integer read fvalue write Setvalue;
    property length : integer read flength write Setlength;
    property max : integer read fmax write Setmax;
    property min : integer read fmin write Setmin;
    property Color : TColor read Color_ write SetCol;
    property Orientation:TOrientation read FOrientation write SetOrientation;
    property Ononchange : TNotifyEvent read fonchange write fonchange;
    property font;
    property ShowHint;
    property ParentShowHint;
    property OnMouseMove;
    property OnMouseDown;
    property OnMouseUp;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnExit;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property TabOrder;
    property TabStop;
    property OnstartDock;
    property OnstartDrag;
    property Visible;
    property Popupmenu;
    property helpcontext;
    property cursor;
    property dragkind;
    property dragmode;
    property dragcursor;
  end;

procedure Register;

implementation

procedure TDelfi_integerselector.Loaded;
begin
posbar.height:=flength;
end;

procedure TDelfi_integerselector.SetOrientation(value:TOrientation);
begin
FOrientation:=value;
if FOrientation = pbHorizontal then posbar.align:=albottom;
if FOrientation = pbvertical then posbar.align:=alright;
if FOrientation = pbHorizontal then posbar.kind:=sbHorizontal;
if FOrientation = pbvertical then posbar.kind:=sbvertical;
if FOrientation = pbHorizontal then posbar.height:=13;
if FOrientation = pbvertical then posbar.width:=13;
edit_.Align:=alclient;
end;

procedure TDelfi_integerselector.Edit_Change(Sender: TObject);
begin
posbar.Position:=strtoint(Edit_.Text);
value:=posbar.Position;
end;

procedure TDelfi_integerselector.posbarChange(Sender: TObject);
begin
if Assigned (fonchange) then Ononchange (self);
Edit_.Text:=inttostr(posbar.Position);
value:=posbar.Position;
end;

procedure TDelfi_integerselector.SetCol(Value: TColor);
begin
Color_ := Value;
edit_.Color:=color_;
end;

constructor TDelfi_integerselector.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
controlstyle := controlstyle - [csAcceptsControls];
//borderstyle:=bsSingle;
bevelouter:=bvlowered;
caption:='';
height:=30;
width:=37;
flength:=8;

color_:=clwindow;

edit_:=tDelfi_edit.Create(self);
edit_.parent:=self;
edit_.Visible:=true;
edit_.Align:=alclient;
edit_.AutoSize:=false;
edit_.BorderStyle:=bsNone;
edit_.OnChange:=Edit_Change;
edit_.onkeypress:=Edit_KeyPress;
edit_.onkeydown:=Edit_Keydown;

posbar:=tscrollbar.create(self);
posbar.parent:=self;
posbar.Visible:=true;
posbar.Align:=albottom;
posbar.TabStop:=false;
posbar.OnChange:=posbarChange;
posbar.height:=8;
length:=8;

fonchange := Nil;
end;

procedure TDelfi_integerselector.Setvalue(Value: integer);
begin
fvalue := value;
posbar.Position:=value;
Edit_.Text:=inttostr(posbar.Position);
posbar.height:=flength;
end;

procedure TDelfi_integerselector.Setlength(Value: integer);
begin
flength:=Value;
posbar.height:=flength;
end;

procedure TDelfi_integerselector.Setmax(Value: integer);
begin
posbar.Max:=value;
fmax := value;
posbar.height:=flength;
end;

procedure TDelfi_integerselector.Setmin(Value: integer);
begin
posbar.min:=value;
fmin := value;
posbar.height:=flength;
end;

procedure TDelfi_integerselector.Edit_KeyPress(Sender: TObject; var Key: Char);
begin
if ((UpCase(Key) < 'A') or
(UpCase(Key) > 'Z')) then begin
if key = '+' then posbar.Position:=posbar.Position+1;
if key = '-' then posbar.Position:=posbar.Position-1;
end;
if ((UpCase(Key) < 'A') or
(UpCase(Key) > 'Z')) then Key := #0;
posbar.height:=flength;
end;

procedure TDelfi_integerselector.Edit_KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
if key = vk_up then posbar.Position:=posbar.Position+1;
if key = vk_down then posbar.Position:=posbar.Position-1;

if key = vk_end then posbar.Position:= max;
if key = vk_home then posbar.Position:=min;
posbar.height:=flength;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_integerselector]);
end;

end.
