// unit Delfi_pathcontrol
//
// an component for selecting folders using 'standard' windows dialog
// by calling SHBrowseForFolder
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

// a part of code is based on Delphi devenloper support faq, question :
// How can I use the Shell API function SHBrowseForFolder() to let the user browse for a folder?

unit Delfi_pathcontrol;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, Delfi_edit, Delfibtn, ShellAPI, ShlObj;

type
  TOrientation = (al_left,al_right);
  TButtonAction = (open,select);
  TDelfi_pathcontrol = class(TCustomPanel)
  procedure Edit_KeyPress(Sender: TObject; var Key: Char);
  procedure buttonclick(Sender: TObject);
  procedure editchange(Sender: TObject);
  private
    { Private declarations }
    color_:tcolor;
    fpath:string;
    ftiltle:string;
    FOrientation:TOrientation;
    FButtonAction:TButtonAction;
    fonchange : TNotifyEvent;
    fflat:boolean;
    fcreatefolder:boolean;
    freadonly_:boolean;
    procedure setflat(Value: boolean);
    procedure setcreatefolder(Value: boolean);
    procedure setreadonly_(Value: boolean);
    procedure SetCol(Value: TColor);
    procedure Setpath(Value: string);
    procedure Settiltle(Value: string);
    procedure SetOrientation(value:TOrientation);
    procedure SetButtonAction(value:TButtonAction);
  protected
    { Protected declarations }
    edit_:tDelfi_edit;
    button:tDelfibtn;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Loaded; override;
  published
    { Published declarations }
    property Align;
    property path : string read fpath write Setpath;
    property tiltle : string read ftiltle write Settiltle;
    property Color : TColor read Color_ write SetCol;
    property Flat : boolean read fflat write Setflat;
    property createfolder : boolean read fcreatefolder write Setcreatefolder;
    property alingment:TOrientation read FOrientation write SetOrientation;
    property ButtonAction:TButtonAction read fButtonAction write SetButtonAction;
    property Ononchange : TNotifyEvent read fonchange write fonchange;
    property readonly_ : boolean read freadonly_ write setreadonly_;
    property font;
    property ShowHint;
    property ParentShowHint;
    property OnMouseMove;
    property OnMouseDown;
    property OnMouseUp;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnExit;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property TabOrder;
    property TabStop;
    property OnstartDock;
    property OnstartDrag;
    property Visible;
    property Popupmenu;
    property helpcontext;
    property cursor;
    property dragkind;
    property dragmode;
    property dragcursor;
  end;

procedure Register;

implementation

procedure TDelfi_pathcontrol.Setflat(Value: boolean);
begin
fflat := Value;
if fflat = true then bevelouter:=bvlowered;
if fflat = true then borderstyle:=bsnone;

if fflat = false then bevelouter:=bvnone;
if fflat = false then borderstyle:=bsSingle;
end;

procedure TDelfi_pathcontrol.Setcreatefolder(Value: boolean);
begin
fcreatefolder := Value;
end;

procedure TDelfi_pathcontrol.Setreadonly_(Value: boolean);
begin
freadonly_ := Value;
edit_.ReadOnly:=freadonly_;
end;

procedure TDelfi_pathcontrol.SetOrientation(value:TOrientation);
begin
FOrientation:=value;
if FOrientation = al_left then button.align:=alleft;
if FOrientation = al_right then button.align:=alright;
end;

procedure TDelfi_pathcontrol.SetButtonAction(value:TButtonAction);
begin
fButtonAction:=value;
end;

procedure TDelfi_pathcontrol.SetCol(Value: TColor);
begin
Color_ := Value;
edit_.Color:=color_;
button.caption:='...';
end;

procedure TDelfi_pathcontrol.Loaded;
begin
button.caption:='...';
button.caption:='...';
button.flat:=true;
end;

destructor TDelfi_pathcontrol.Destroy;
begin
inherited;

end;

constructor TDelfi_pathcontrol.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
controlstyle := controlstyle - [csAcceptsControls];
borderstyle:=bsSingle;
bevelouter:=bvnone;
caption:='';
height:=23;
width:=130;

ButtonAction:=select;

ftiltle:='select folder';

FOrientation := al_right;

color_:=clwindow;

edit_:=tDelfi_edit.Create(self);
edit_.parent:=self;
edit_.Visible:=true;
edit_.Align:=alclient;
edit_.AutoSize:=false;
edit_.BorderStyle:=bsNone;
edit_.onkeypress:=Edit_KeyPress;

button:=tdelfibtn.create(self);
button.parent:=self;
button.Visible:=true;
button.Align:=alright;
button.width:=18;
button.font.size:=7;
button.Font.name:='Arial';
button.onclick:=buttonclick;

fonchange := Nil;
end;

procedure TDelfi_pathcontrol.Setpath(Value: string);
begin
fpath := value;
edit_.Text:=fpath;
end;

procedure TDelfi_pathcontrol.Settiltle(Value: string);
begin
ftiltle := value;
end;

function DirectoryExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

procedure TDelfi_pathcontrol.editchange(Sender: TObject);
begin

end;

procedure TDelfi_pathcontrol.buttonclick(Sender: TObject);
var
TitleName : string;
lpItemID : PItemIDList;
BrowseInfo : TBrowseInfo;
DisplayName : array[0..MAX_PATH] of char;
TempPath : array[0..MAX_PATH] of char;
begin
if ButtonAction = open then begin

try
if fcreatefolder = true then if DirectoryExists(edit_.Text) = false then CreateDir(edit_.Text);
except end;

if DirectoryExists(edit_.Text) = true then WinExec(pchar('explorer '+edit_.Text), SW_SHOWDEFAULT);
end;
if ButtonAction = select then begin
FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
BrowseInfo.hwndOwner := application.Handle;
BrowseInfo.pszDisplayName := @DisplayName;
TitleName := ftiltle;
BrowseInfo.lpszTitle := PChar(TitleName);
BrowseInfo.ulFlags := BIF_RETURNONLYFSDIRS + BIF_EDITBOX + $0040;
lpItemID := SHBrowseForFolder(BrowseInfo);
if lpItemId <> nil then begin
SHGetPathFromIDList(lpItemID, TempPath);
edit_.Text:=TempPath;
fpath:=edit_.Text;
GlobalFreePtr(lpItemID);
if Assigned (fonchange) then Ononchange (self);
end;
end;
end;

procedure TDelfi_pathcontrol.Edit_KeyPress(Sender: TObject; var Key: Char);
begin
// name of folders may not contain : '\*?"<>|'
// name of files may not contain : '/\:*?"<>|'
if key = '/' then key := #0;
if key = '*' then key := #0;
if key = '?' then key := #0;
if key = '"' then key := #0;
if key = '<' then key := #0;
if key = '>' then key := #0;
if key = '|' then key := #0;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_pathcontrol]);
end;

end.

