// unit Delfi_trayicon
//
// a tray icon for Delphi applications
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

//if not (csDesigning in ComponentState) then ShowWindow(Application.Handle, SW_HIDE);

unit Delfi_trayicon;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI, menus;

type
  TDelfi_trayicon = class(Tcomponent)
  private
    { Private declarations }
    fIcon : TIcon;
    fToolTip : String;
    fWindowHandle : HWND;
    fActive : boolean;
    fno_taskbarbutton : boolean;
    fOnClick     : TNotifyEvent;
    fOnDblClick  : TNotifyEvent;
    fOnRightBtnClick : TNotifyEvent;
    fPopupMenu   : TPopupMenu;
    added:boolean;
    procedure SetActive(Value : boolean);
    procedure Setno_taskbarbutton(Value : boolean);
    procedure SetIcon(Value : TIcon);
    procedure SetToolTip(Value : String);
    procedure WndProc(var msg : TMessage);
  protected
    { Protected declarations }
    FMessageID: DWORD;
    hMapping: THandle;
    IconData: TNOTIFYICONDATA;
  public
    { Public declarations }
    constructor create(aOwner : TComponent); override;
    procedure createicon(icon_:ticon;tip_:string);
    procedure Loaded; override;
    destructor destroy; override;
  published
    { Published declarations }
    property Active : boolean read fActive write SetActive;
    property no_taskbarbutton : boolean read fno_taskbarbutton write Setno_taskbarbutton;
    property Icon : TIcon read fIcon write SetIcon;
    property ToolTip : string read fTooltip write SetToolTip;
    property OnClick     : TNotifyEvent read FOnClick write FOnClick;
    property OnDblClick  : TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnRightBtnClick :  TNotifyEvent read FOnRightBtnClick write FonRightBtnClick;
    property PopupMenu : TPopupMenu read fPopupMenu write fPopupMenu;
  end;

procedure Register;

implementation

procedure TDelfi_trayicon.WndProc(var msg : TMessage);
var pt:tpoint;
begin
if not (csDesigning in ComponentState) then begin
if (msg.Msg = WM_USER + 1000) then begin
case msg.lParam of
WM_LBUTTONDBLCLK   : if assigned(FOnDblClick) then FOnDblClick(self);
WM_LBUTTONUP       : if assigned(FOnClick)then FOnClick(self);
WM_RBUTTONUP : begin
if assigned(fPopupMenu) then begin
GetCursorPos(pt);
fPopupMenu.popup(pt.x,pt.y);
end;
if assigned(fOnRightBtnClick) then OnRightBtnClick(self);
end;
end;
end
else
msg.Result := DefWindowProc(FWindowHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;
// WM_SYSTEMERROR      = $0017;
if fno_taskbarbutton = true then if not (csDesigning in ComponentState) then ShowWindow(Application.Handle, SW_HIDE)
else if not (csDesigning in ComponentState) then ShowWindow(Application.Handle, SW_show)
end;

procedure TDelfi_trayicon.createicon(icon_:ticon;tip_:string);
begin
if fActive = false then begin
try
Shell_NotifyIcon(NIM_DELETE, @IconData);
except end;
end;

if fActive = true then begin
try
//Shell_NotifyIcon(NIM_DELETE, @IconData);
except end;

IconData.cbSize := sizeof(IconData);
IconData.Wnd := FWindowHandle;
IconData.uID := 100;
IconData.uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;

if not (csDesigning in ComponentState) then begin
IconData.uCallbackMessage := WM_USER + 1000;
end;

IconData.hIcon := icon_.Handle;
StrPCopy(IconData.szTip, tip_);

if added = true then Shell_NotifyIcon(NIM_MODIFY, @IconData);
if added = false then Shell_NotifyIcon(NIM_ADD, @IconData);

added:=true;

end;
end;

procedure TDelfi_trayicon.Loaded;
begin

end;

procedure TDelfi_trayicon.SetActive(Value : boolean);
begin
if value <> fActive then begin
fActive := Value;
added:=false;
createicon(ficon,fToolTip);
end;
end;

procedure TDelfi_trayicon.Setno_taskbarbutton(Value : boolean);
begin
if value <> fno_taskbarbutton then begin
fno_taskbarbutton := Value;
if value = true then if not (csDesigning in ComponentState) then ShowWindow(Application.Handle, SW_HIDE);
if value = false then if not (csDesigning in ComponentState) then ShowWindow(Application.Handle, SW_show);
end;
end;

procedure TDelfi_trayicon.SetIcon(Value : ticon);
begin
if Value <> fIcon then fIcon.Assign(value);
added:=true;
createicon(ficon,fToolTip);
end;

procedure TDelfi_trayicon.SetToolTip(Value : string);
begin
fToolTip := value;
if fToolTip = '' then fToolTip := ' ';
added:=true;
createicon(ficon,fToolTip);
end;

constructor TDelfi_trayicon.create(aOwner : Tcomponent);
begin
inherited create(aOwner);
added:=false;
if not (csDesigning in ComponentState) then begin
FWindowHandle := AllocateHWnd( WndProc );
end;
FIcon := TIcon.Create;
end;

destructor TDelfi_trayicon.destroy;
begin
FIcon.Free;
Shell_NotifyIcon(NIM_DELETE, @IconData);
inherited destroy;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_trayicon]);
end;

end.
