// unit Delfi_updown
//
// another updown component
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_updown;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Delfi_edit, delfibtn;

type
  TDelfi_updown = class(TCustomPanel)
  procedure Edit_Change(Sender: TObject);
  procedure Edit_KeyPress(Sender: TObject; var Key: Char);
  procedure Edit_Keydown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure Edit_KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure positioner_(Sender: TObject);
  procedure buttonizer_(Sender: TObject);
  procedure buttonizer_mouseup(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  procedure buttonizer_mousedn(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
    color_:tcolor;
    fvalue:integer;
    flength:integer;
    fmax:integer;
    fmin:integer;
    fupbitmap:tbitmap;
    fdnbitmap:tbitmap;
    fflat:boolean;
    fonchange : TNotifyEvent;
    procedure SetCol(Value: TColor);
    procedure Setvalue(Value: integer);
    procedure Setlength(Value: integer);
    procedure Setupbitmap(Value: tbitmap);
    procedure Setdnbitmap(Value: tbitmap);
    procedure Setmin(Value: integer);
    procedure Setmax(Value: integer);
    procedure setflat(Value: boolean);
  protected
    { Protected declarations }
  edit_:tDelfi_edit;
  positioner:ttimer;
  buttonizer_up:tDelfibtn;
  buttonizer_dn:tDelfibtn;
  direction_up:boolean;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Loaded; override;
  published
    { Published declarations }
    property Align;
    property value : integer read fvalue write Setvalue;
    property length : integer read flength write Setlength;
    property max : integer read fmax write Setmax;
    property min : integer read fmin write Setmin;
    property Color : TColor read Color_ write SetCol;
    property upbitmap : tbitmap read fupbitmap write Setupbitmap;
    property dnbitmap : tbitmap read fdnbitmap write Setdnbitmap;
    property Flat : boolean read fflat write Setflat;
    property Ononchange : TNotifyEvent read fonchange write fonchange;
    property font;
    property ShowHint;
    property ParentShowHint;
    property OnMouseMove;
    property OnMouseDown;
    property OnMouseUp;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnExit;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property TabOrder;
    property TabStop;
    property OnstartDock;
    property OnstartDrag;
    property Visible;
    property Popupmenu;
    property helpcontext;
    property cursor;
    property dragkind;
    property dragmode;
    property dragcursor;
  end;

procedure Register;

implementation

procedure TDelfi_updown.Edit_Change(Sender: TObject);
begin
if Assigned (fonchange) then Ononchange (self);
if strtoint(Edit_.Text) <> min then strtoint(Edit_.Text);
if strtoint(Edit_.Text) <> max then strtoint(Edit_.Text);
end;

procedure TDelfi_updown.buttonizer_(Sender: TObject);
begin

end;

procedure TDelfi_updown.buttonizer_mouseup(Sender: TObject; Button: TMouseButton;
Shift: TShiftState; X, Y: Integer);
begin
positioner.Enabled:=false;
end;

procedure TDelfi_updown.buttonizer_mousedn(Sender: TObject; Button: TMouseButton;
Shift: TShiftState; X, Y: Integer);
begin
if max + min = 0 then begin
if (Sender as tdelfibtn).tag = 2 then value:=value-1;
if (Sender as tdelfibtn).tag = 1 then value:=value+1;
end;

if max + min <> 0 then begin
if (Sender as tdelfibtn).tag = 2 then if value <> min then value:=value-1;
if (Sender as tdelfibtn).tag = 1 then if value <> max then value:=value+1;
end;

if (Sender as tdelfibtn).tag = 2 then direction_up:=true;
if (Sender as tdelfibtn).tag = 1 then direction_up:=false;
positioner.Enabled:=true;
end;

procedure TDelfi_updown.positioner_(Sender: TObject);
begin
if direction_up = true then begin
if value <> min then value:=value-1;
end;
if direction_up = false then begin
if max = 0 then value:=value+1 else if value <> max then value:=value+1;
end;
end;

procedure TDelfi_updown.SetCol(Value: TColor);
begin
Color_ := Value;
edit_.Color:=color_;
end;

procedure TDelfi_updown.Setflat(Value: boolean);
begin
fflat := Value;
if fflat = true then bevelouter:=bvlowered;
if fflat = true then borderstyle:=bsnone;

if fflat = false then bevelouter:=bvnone;
if fflat = false then borderstyle:=bsSingle;
end;

procedure TDelfi_updown.loaded;
begin
inherited;
buttonizer_up.drawfocusrect:=false;
buttonizer_up.Font.Name:='Webdings';
buttonizer_up.Font.Size:=8;
buttonizer_up.flat:=true;
buttonizer_up.Tag:=1;

buttonizer_dn.drawfocusrect:=false;
buttonizer_dn.Font.Name:='Webdings';
buttonizer_dn.Font.Size:=8;
buttonizer_dn.flat:=true;
buttonizer_dn.Tag:=2;

buttonizer_up.glyph:=fupbitmap;
buttonizer_dn.glyph:=fdnbitmap;

if fupbitmap.empty = true then buttonizer_up.caption:='5';
if fdnbitmap.empty = true then buttonizer_dn.caption:='6';

end;

constructor TDelfi_updown.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
controlstyle := controlstyle - [csAcceptsControls];
setflat(fflat);
caption:='';
height:=20;
width:=130;
flength:=12;

fupbitmap:=tbitmap.create;
fdnbitmap:=tbitmap.create;

color_:=clwindow;

edit_:=tDelfi_edit.Create(self);
edit_.parent:=self;
edit_.Visible:=true;
edit_.Align:=alclient;
edit_.AutoSize:=false;
edit_.BorderStyle:=bsNone;
edit_.OnChange:=Edit_Change;
edit_.onkeypress:=Edit_KeyPress;
edit_.onkeydown:=Edit_Keydown;
edit_.onkeyup:=Edit_Keyup;

buttonizer_dn:=tDelfibtn.Create(self);
buttonizer_dn.parent:=self;
buttonizer_dn.Visible:=true;
buttonizer_dn.Align:=alright;
buttonizer_dn.width:=length;
buttonizer_dn.onmousedown:=buttonizer_mousedn;
buttonizer_dn.onmouseup:=buttonizer_mouseup;

buttonizer_up:=tDelfibtn.Create(self);
buttonizer_up.parent:=self;
buttonizer_up.Visible:=true;
buttonizer_up.Align:=alright;
buttonizer_up.width:=length;
buttonizer_up.onmousedown:=buttonizer_mousedn;
buttonizer_up.onmouseup:=buttonizer_mouseup;

// timer
positioner:=ttimer.create(self);
positioner.OnTimer:=positioner_;
positioner.enabled:=false;
positioner.interval:=100;

fonchange := Nil;
end;

procedure TDelfi_updown.Setvalue(Value: integer);
begin
fvalue := value;
Edit_.Text:=inttostr(fvalue);
end;

procedure TDelfi_updown.Setlength(Value: integer);
begin
flength:=Value;
buttonizer_dn.width:=length;
buttonizer_up.width:=length;
end;

procedure TDelfi_updown.Setmax(Value: integer);
begin
fmax := value;
end;

procedure TDelfi_updown.Setmin(Value: integer);
begin
fmin := value;
end;

        ////////

procedure TDelfi_updown.Setupbitmap(Value: tbitmap);
begin
fupbitmap.Assign(Value);
buttonizer_up.glyph:=fupbitmap;

if fupbitmap.empty = true then buttonizer_up.caption:='5';

invalidate;
end;

procedure TDelfi_updown.Setdnbitmap(Value: tbitmap);
begin
fdnbitmap.Assign(Value);
buttonizer_dn.glyph:=fdnbitmap;

if fdnbitmap.empty = true then buttonizer_dn.caption:='6';

invalidate;
end;

procedure TDelfi_updown.Edit_KeyPress(Sender: TObject; var Key: Char);
begin
if ((UpCase(Key) < 'A') or
(UpCase(Key) > 'Z')) then begin
if key = '+' then if value <> max then value:=value+1;
if key = '-' then if value <> min then value:=value-1;
end;
if ((UpCase(Key) < 'A') or
(UpCase(Key) > 'Z')) then Key := #0;
positioner.Enabled:=false;
buttonizer_up.down:=false;
buttonizer_dn.down:=false;
end;

procedure TDelfi_updown.Edit_KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
if key = vk_up then value:=value+1;
if key = vk_down then value:=value-1;

if max <> 0 then if value <> 0 then begin
if value < min then value:=min;
if value > max then value:=max;
end
else value:=0;

if max = 0 then if value <> 0 then begin
if value < min then value:=min;
end
else value:=0;

if key = vk_up then direction_up:=false;
if key = vk_down then direction_up:=true;

if key = vk_up then positioner.Enabled:=true;
if key = vk_down then positioner.Enabled:=true;

if key = vk_down then buttonizer_dn.down:=true;
if key = vk_up then buttonizer_up.down:=true;

if key = vk_end then value:= min;
if key = vk_home then value := max;
end;

procedure TDelfi_updown.Edit_Keyup(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
positioner.Enabled:=false;
buttonizer_up.down:=false;
buttonizer_dn.down:=false;
end;

destructor TDelfi_updown.Destroy;
begin
inherited;
//fupbitmap.FreeImage;
//fdnbitmap.FreeImage;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_updown]);
end;

end.
