// unit Delfi_wave_info
//
// component that gives you information about wav file
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// but you may not change the AUTHOR you must leave ALL comments here !
//
// if you improved this component add your comment after this line

// based on some code from :

// Signal display component demo program
//
// Author:	Robert Rossmair
//	Wagelwitz, Rodaer Str. 6
//	04688 Mutzschen
//	Germany
//
//	e-mail:	Robert.Rossmair@t-online.de
//	http://home.t-online.de/home/Robert.Rossmair/
//
// Module:	ZoomMain
//
// Version:	1.7.3, 21-May-1999
//
// Copyright  1998  Robert Rossmair

unit Delfi_wave_info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem;

type
  TDelfi_wave_info = class(TComponent)
  private
    { Private declarations }
  fFormat:integer;
  fchannels:integer;
  fbits:integer;
  fDatabytes:integer;
  fsamplespersecond:integer;
  fbytespersecond:integer;
  protected
    { Protected declarations }
  Buf: PByteArray;
  public
    { Public declarations }
  published
    { Published declarations }
  procedure ReadWavFile(FileName: string);
  property Format : integer read fFormat write fFormat;
  property channels : integer read fchannels write fchannels;
  property Bits : integer read fbits write fbits;
  property Databytes : integer read fDatabytes write fDatabytes;
  property samplespersec : integer read fsamplespersecond write fsamplespersecond;
  property Bytespersec : integer read fbytespersecond write fbytespersecond;
  end;

procedure Register;

implementation

const
  Wave_Format_ADPCM = 2;
  MSADPCM_NUM_COEF = 7;
type
  ArrayIndex = 0..99999999;
  TByteArray = array[ArrayIndex] of Byte;
  PByteArray = ^TByteArray;
  TSmallintArray = array[ArrayIndex] of Smallint;
  PSmallintArray = ^TSmallintArray;

  TADPCMCoef = packed record
    Coef1, Coef2: SmallInt;
  end;

  TADPCMCoefSet = Array[0..MSADPCM_NUM_COEF-1] of TADPCMCoef;
  PADPCMCoefSet = ^TADPCMCoefSet;

TWaveFormatEx = packed record
    wFormatTag: Word;         { format type }
    nChannels: Word;          { number of channels (i.e. mono, stereo, etc.) }
    nSamplesPerSec: Longint;  { sample rate }
    nAvgBytesPerSec: Longint; { for buffer estimation }
    nBlockAlign: Word;        { block size of data }
    wBitsPerSample: Word;
    cbSize: Word;  { SizeOf(wSamplesPerBlock..Predictors. Optional with PCM }
    wSamplesPerBlock: SmallInt;
    wNumCoef: SmallInt;  { const 7 }
    CoefSet: TADPCMCoefSet;
end;
PWaveFormatEx = ^TWaveFormatEx;

procedure TDelfi_wave_info.ReadWavFile(FileName: string);
var
 mmioHandle: Integer;
 SampleCount, DataBytes: LongInt;
 SrcFormat: TWaveFormatEx;
 ckRIFF, ck: TMMCKINFO;
begin
 FreeMem(Buf);
 Buf := nil;
 if (FileName = '') or not FileExists(FileName)
 then showmessage('File '+FileName+' not found.');
 mmioHandle := mmioOpen(PChar(FileName), nil, MMIO_READ or MMIO_ALLOCBUF);
 if mmioHandle = 0 then showmessage('mmioOpen failed');
 try
 ckRIFF.fccType := mmioStringToFourCC('WAVE',0);
 if mmioDescend(mmioHandle, @ckRIFF, nil, MMIO_FINDRIFF) <> 0
 then showmessage('WAVE chunk not found');

 FillChar(SrcFormat,SizeOf(SrcFormat), 0);
 SampleCount := 0;

 while mmioDescend(mmioHandle, @ck, @ckRIFF, 0) = MMSYSERR_NOERROR do
 begin
 if (ck.dwDataOffset + ck.cksize) > (ckRIFF.dwDataOffset + ckRIFF.cksize)
 then showmessage('Chunk size mismatch');
 if ck.ckid = mmioStringToFourCC('fmt ',0) then
 begin
 if SrcFormat.wFormatTag = 0 then
 begin
 if ck.ckSize > SizeOf(TWaveFormatEx)
 then showmessage('ADPCM, unexpected number of coefficients');
 if mmioRead(mmioHandle, @SrcFormat, ck.ckSize) <> ck.ckSize
 then showmessage('Error reading ''fmt '' chunk');
 end;
 end else if ck.ckid = mmioStringToFourCC('fact',0) then
 begin
 if (SampleCount = 0) and (SrcFormat.wFormatTag = Wave_Format_ADPCM) then
 begin
 mmioRead(mmioHandle, @SampleCount, SizeOf(LongInt));
 end; { else multiple fact chunks - ignore }
 end else if ck.ckid = mmioStringToFourCC('data',0) then
 begin
 DataBytes := ck.cksize;
 case SrcFormat.wFormatTag of
 WAVE_INVALIDFORMAT: showmessage('not a wav');
 Wave_Format_PCM:
 with SrcFormat do SampleCount := DataBytes div (nAvgBytesPerSec div nSamplesPerSec);
 Wave_Format_ADPCM: ;
 else
 end;
 GetMem(Buf, DataBytes);
 mmioRead(mmioHandle, PChar(Buf), DataBytes);

 fFormat:=SrcFormat.wFormatTag;
 fchannels:=SrcFormat.nChannels;
 fbits:=SrcFormat.wBitsPerSample;
 fDatabytes:=DataBytes;
 fsamplespersecond:=SrcFormat.nSamplesPerSec;
 fbytespersecond:=SrcFormat.nAvgBytesPerSec;

 end;
 mmioAscend(mmioHandle, @ck, 0);
 end;
 finally
 mmioClose(mmioHandle,0);
 end;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_wave_info]);
end;

end.
 
