// unit Delfibtn
//
// additional button that can have glyphs and you can change color
// this button looks like i wanted
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfibtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, menus;

type
  TDelfibtn = class(TcustomControl)
  private
    Bmp: TBitmap;
    Bmp_down: TBitmap;
    caption_ : string;
    fcaption_down_ : string;
    color_ : TColor;
    focused___:boolean;
    drawfocusrect_:boolean;
    spacedown:boolean;
    fdown:boolean;
    fcheckbox:boolean;
    _color_light : TColor;
    _color_shadow : TColor;
    fbordercolor : TColor;
    froundededges:boolean;
    MDown: TMouseEvent;
    MUp: TMouseEvent;
    Enab: Boolean;
    fpopup_:tpopupmenu;
    fflat:boolean;
    BtnClick: TNotifyEvent;
    procedure SetCol(Value: TColor);
    procedure setdrawfocusrect(Value: boolean);
    procedure setdown(Value: boolean);
    procedure setcheckbox(Value: boolean);
    procedure setpopup_(Value: tpopupmenu);
    procedure set_color_light(Value: TColor);
    procedure set_color_shadow(Value: TColor);
    procedure set_bordercolor(Value: TColor);
    procedure SetCap(Value: string);
    procedure SetCap_down_(Value: string);
    procedure SetBmp(Value: TBitmap);
    procedure Set_Bmp_down(Value: TBitmap);
    procedure setroundededges(Value: boolean);
    procedure setflat(Value: boolean);
    procedure CMEnter(var message:TCMGotFocus);message CM_ENTER;
    procedure CMExit(var Message:TCMExit);message CM_EXIT;
    procedure WMSETFOCUS (var message: TMessage); message  WM_SETFOCUS;
    procedure WMKILLFOCUS (var message: TMessage); message WM_KILLFOCUS;
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: char); override;
    procedure SetParent(Value: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click;
  published
    property Align;
    property DrawFocusrect : boolean read drawfocusrect_ write Setdrawfocusrect;
    property down : boolean read fdown write setdown;
    property checkbox : boolean read fcheckbox write Setcheckbox;
    property Caption : string read Caption_ write SetCap;
    property Caption_down : string read fcaption_down_ write setcap_down_;
    property Color : TColor read Color_ write SetCol;
    property color_light : TColor read _color_light write set_color_light default clwhite ;
    property color_shadow : TColor read _color_shadow write set_color_shadow default clgray ;
    property bordercolor : TColor read fbordercolor write set_bordercolor default clgray ;
    property popup_: Tpopupmenu read fpopup_ write setpopup_;
    property Enabled : Boolean read Enab write Enab;
    property roundededges : Boolean read froundededges write setroundededges;
    property flat : Boolean read fflat write setflat;
    property OnMouseDown: TMouseEvent read MDown write MDown;
    property OnMouseUp: TMouseEvent read MUp write MUp;
    property OnClick: TNotifyEvent read BtnClick write BtnClick;
    property Font;
    property Glyph: TBitmap read Bmp write SetBmp;
    property Glyph_down: TBitmap read Bmp_down write Set_Bmp_down;
    property ShowHint;
    property OnMouseMove;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnExit;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property TabOrder;
    property TabStop;
    property OnstartDock;
    property OnstartDrag;
    property Visible;
    property Popupmenu;
    property helpcontext;
    property cursor;
    property dragkind;
    property dragmode;
    property dragcursor;
  end;

procedure Register;

implementation

var Pos: TPoint;

procedure TDelfibtn.SetBmp(Value: TBitmap);
//var i,i_:integer;
//replcolor:tcolor;
begin
Bmp.Assign(value);

if bmp_down.empty = true then Set_Bmp_down(bmp);

(*Bmp.PixelFormat:= pf24Bit;
replcolor:=Bmp.canvas.Pixels[0,0];
for i_:=0 to Bmp.width do
begin
for i:=0 to Bmp.height do
begin
if Bmp.canvas.Pixels[i_,i]=replcolor then Bmp.canvas.Pixels[i_,i]:=color_;
end;
end;*)

invalidate;
end;

procedure TDelfibtn.Set_Bmp_down(Value: TBitmap);
//var i,i_:integer;
//replcolor:tcolor;
begin
Bmp_down.Assign(Value);
(*Bmp_down.PixelFormat:= pf24Bit;
replcolor:=Bmp_down.canvas.Pixels[0,0];
for i_:=0 to Bmp_down.width do
begin
for i:=0 to Bmp_down.height do
begin
if Bmp_down.canvas.Pixels[i_,i]=replcolor then Bmp_down.canvas.Pixels[i_,i]:=color_;
end;
end;*)
invalidate;
end;

procedure TDelfibtn.setpopup_(Value: tpopupmenu);
begin
fpopup_:=Value;
end;

procedure TDelfibtn.Click;
begin
if Enab then if Assigned(BtnClick) then BtnClick(Self);
pos := ClientToScreen(Point(0, Height)); if Enab = true then if fpopup_ <> nil then fpopup_.Popup(Pos.X,Pos.Y);
end;

constructor TDelfibtn.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
controlstyle:=controlstyle + [csOpaque];
Bmp := TBitmap.Create;
Bmp_down := TBitmap.Create;
Width := 83;
Height := 23;
drawfocusrect_:=true;
Color_ := clbtnface;
_color_light := clwhite;
_color_shadow := clgray;
fbordercolor:=clblack;
Font.Name := 'Arial';
Font.Color := clblack;
Font.Size := 8;
Enab := true;
ShowHint := true;
TabStop := True;
end;

destructor TDelfibtn.Destroy;
begin
inherited Destroy;
Bmp.FreeImage;
Bmp_down.FreeImage;
end;

procedure TDelfibtn.SetParent(Value: TWinControl);
begin
inherited;
//if csdesigning in componentstate then if Value <> nil then Caption_ := Name;
end;

procedure TDelfibtn.Paint;
var TextWidth, TextHeight : Longint;
Frame:TRect;
begin
if fflat = false then begin
if down = false then begin

Canvas.Brush.Color:=Color_;
Canvas.FillRect(Canvas.ClipRect);

Canvas.Font := Font;

Canvas.Brush.Color := Color_;

TextWidth := Canvas.TextWidth(Caption_);
TextHeight := Canvas.TextHeight(Caption_);
Canvas.Font.Color := Font.Color;

if bmp.Empty = false then begin
//Canvas.Draw(Width div 2 - (bmp.Width+TextWidth) div 2-1,Height div 2 - bmp.Height div 2,bmp);

Canvas.Font.Assign(Font);
Canvas.Font.Color := Font.Color;

Canvas.BrushCopy(Rect(Width div 2 - (bmp.Width+TextWidth) div 2-1,
Height div 2 - bmp.Height div 2,
Width div 2 - (bmp.Width+TextWidth) div 2-1+(bmp.Width),
//bmp.width+Width div 2 - (3+bmp.Width+TextWidth) div 2,
bmp.height+Height div 2 - bmp.Height div 2),
bmp,
Rect(0,0,bmp.width,bmp.height),
bmp.Canvas.pixels[0,0]);
//
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(Width div 2 + (bmp.Width-TextWidth) div 2+5-1,Height div 2-TextHeight div 2,Caption_);
end;

if bmp.Empty = true then begin
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(Width div 2 - TextWidth div 2,Height div 2-TextHeight div 2,Caption_);
end;

canvas.pen.Color:=fbordercolor;
canvas.Brush.Color:=color_;

canvas.MoveTo(0,0);
canvas.lineto(width-1,0);
canvas.lineto(width-1,height-1);
canvas.MoveTo(width-1,height-1);
canvas.lineto(0,height-1);
canvas.lineto(0,0);

canvas.pen.Color:=_color_light;
canvas.MoveTo(1,1);
canvas.lineto(width-2,1);
canvas.MoveTo(1,1);
canvas.lineto(1,height-2);

canvas.pen.Color:=_color_shadow;
canvas.MoveTo(width-2,height-2);
canvas.lineto(width-2,1);
canvas.MoveTo(width-2,height-2);
canvas.lineto(1,height-2);

if drawfocusrect_ then begin
Frame := GetClientRect;
if focused___ then begin
Frame := Rect(Frame.Left+3,Frame.Top+3,Frame.Right-3,Frame.Bottom-3);
Canvas.DrawFocusRect(Frame);
end;
end;
inherited Paint;
end;

if down = true then begin

Canvas.Brush.Color:=Color_;
Canvas.FillRect(Canvas.ClipRect);

Canvas.Font := Font;
Canvas.Brush.Color := Color_;

TextWidth := Canvas.TextWidth(fcaption_down_);
TextHeight := Canvas.TextHeight(fcaption_down_);
Canvas.Font.Color := Font.Color;

if Bmp_down.Empty = false then begin
//Canvas.Draw(1+Width div 2 - (Bmp_down.Width+TextWidth) div 2-1,1+Height div 2 - Bmp_down.Height div 2,Bmp_down);

//
Canvas.BrushCopy(Rect(1+Width div 2 - (bmp_down.Width+TextWidth) div 2-1,
1+Height div 2 - bmp_down.Height div 2,
1+Width div 2 - (bmp_down.Width+TextWidth) div 2-1+(bmp_down.Width),
//bmp_down.width+Width div 2 - (3+bmp_down.Width+TextWidth) div 2,
1+bmp_down.height+Height div 2 - bmp_down.Height div 2),
bmp_down,
Rect(0,0,bmp_down.width,bmp_down.height),
bmp_down.Canvas.pixels[0,0]);
//

Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(1+Width div 2 + (Bmp_down.Width-TextWidth) div 2+5-1,1+Height div 2-TextHeight div 2,fcaption_down_);
end;

if Bmp_down.Empty = true then begin
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(1+Width div 2 - TextWidth div 2,1+Height div 2-TextHeight div 2,fcaption_down_);
end;

canvas.pen.Color:=fbordercolor;
canvas.Brush.Color:=color_;

canvas.MoveTo(0,0);
canvas.lineto(width-1,0);
canvas.lineto(width-1,height-1);
canvas.MoveTo(width-1,height-1);
canvas.lineto(0,height-1);
canvas.lineto(0,0);

canvas.pen.Color:=_color_shadow;
canvas.MoveTo(1,1);
canvas.lineto(width-2,1);
canvas.MoveTo(1,1);
canvas.lineto(1,height-2);

canvas.pen.Color:=_color_light;
canvas.MoveTo(width-2,height-2);
canvas.lineto(width-2,1);
canvas.MoveTo(width-2,height-2);
canvas.lineto(1,height-2);

if drawfocusrect_ then begin
Frame := GetClientRect;
if focused___ then begin
Frame := Rect(Frame.Left+3,Frame.Top+3,Frame.Right-3,Frame.Bottom-3);
Canvas.DrawFocusRect(Frame);
end;
end;
end;
end;

        //////// flat

if fflat = true then begin
if down = false then begin

Canvas.Brush.Color:=Color_;
Canvas.FillRect(Canvas.ClipRect);

Canvas.Font := Font;

Canvas.Brush.Color := Color_;

TextWidth := Canvas.TextWidth(Caption_);
TextHeight := Canvas.TextHeight(Caption_);
Canvas.Font.Color := Font.Color;

if bmp.Empty = false then begin
//Canvas.Draw(Width div 2 - (bmp.Width+TextWidth) div 2-1,Height div 2 - bmp.Height div 2,bmp);

Canvas.Font.Assign(Font);
Canvas.Font.Color := Font.Color;

Canvas.BrushCopy(Rect(Width div 2 - (bmp.Width+TextWidth) div 2-1,
Height div 2 - bmp.Height div 2,
Width div 2 - (bmp.Width+TextWidth) div 2-1+(bmp.Width),
//bmp.width+Width div 2 - (3+bmp.Width+TextWidth) div 2,
bmp.height+Height div 2 - bmp.Height div 2),
bmp,
Rect(0,0,bmp.width,bmp.height),
bmp.Canvas.pixels[0,0]);
//
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(Width div 2 + (bmp.Width-TextWidth) div 2+5-1,Height div 2-TextHeight div 2,Caption_);
end;

if bmp.Empty = true then begin
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(Width div 2 - TextWidth div 2,Height div 2-TextHeight div 2,Caption_);
end;

canvas.pen.Color:=_color_light;
canvas.MoveTo(0,0);
canvas.lineto(width,0);
canvas.MoveTo(0,0);
canvas.lineto(0,height);

canvas.pen.Color:=_color_shadow;
canvas.MoveTo(width-1,height-1);
canvas.lineto(width-1,0);
canvas.MoveTo(width-1,height-1);
canvas.lineto(0,height-1);

if drawfocusrect_ then begin
Frame := GetClientRect;
if focused___ then begin
Frame := Rect(Frame.Left+2,Frame.Top+2,Frame.Right-2,Frame.Bottom-2);
Canvas.DrawFocusRect(Frame);
end;
end;
inherited Paint;
end;

if down = true then begin

Canvas.Brush.Color:=Color_;
Canvas.FillRect(Canvas.ClipRect);

Canvas.Font := Font;
Canvas.Brush.Color := Color_;

TextWidth := Canvas.TextWidth(fcaption_down_);
TextHeight := Canvas.TextHeight(fcaption_down_);
Canvas.Font.Color := Font.Color;

if Bmp_down.Empty = false then begin
//Canvas.Draw(1+Width div 2 - (Bmp_down.Width+TextWidth) div 2-1,1+Height div 2 - Bmp_down.Height div 2,Bmp_down);

//
Canvas.BrushCopy(Rect(1+Width div 2 - (bmp_down.Width+TextWidth) div 2-1,
1+Height div 2 - bmp_down.Height div 2,
1+Width div 2 - (bmp_down.Width+TextWidth) div 2-1+(bmp_down.Width),
//bmp_down.width+Width div 2 - (3+bmp_down.Width+TextWidth) div 2,
1+bmp_down.height+Height div 2 - bmp_down.Height div 2),
bmp_down,
Rect(0,0,bmp_down.width,bmp_down.height),
bmp_down.Canvas.pixels[0,0]);
//

Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(1+Width div 2 + (Bmp_down.Width-TextWidth) div 2+5-1,1+Height div 2-TextHeight div 2,fcaption_down_);
end;

if Bmp_down.Empty = true then begin
Canvas.Brush.Color := Color_;
Canvas.Font.Color := Font.Color;
Canvas.TextOut(1+Width div 2 - TextWidth div 2,1+Height div 2-TextHeight div 2,fcaption_down_);
end;

canvas.pen.Color:=_color_shadow;
canvas.MoveTo(0,0);
canvas.lineto(width,0);
canvas.MoveTo(0,0);
canvas.lineto(0,height);

canvas.pen.Color:=_color_light;
canvas.MoveTo(width-1,height-1);
canvas.lineto(width-1,0);
canvas.MoveTo(width-1,height-1);
canvas.lineto(0,height-1);

if drawfocusrect_ then begin
Frame := GetClientRect;
if focused___ then begin
Frame := Rect(Frame.Left+2,Frame.Top+2,Frame.Right-2,Frame.Bottom-2);
Canvas.DrawFocusRect(Frame);
end;
end;
end;
end;

if froundededges = true then begin
canvas.Pixels[0,0]:=color;
canvas.Pixels[0,height-1]:=color;
canvas.Pixels[width-1,0]:=color;
canvas.Pixels[width-1,height-1]:=color;
end;
end;

procedure TDelfibtn.Setdrawfocusrect(Value: boolean);
begin
drawfocusrect_ := Value;
Paint;
end;

procedure TDelfibtn.setdown(Value: boolean);
begin
fdown := Value;
Paint;
end;

procedure TDelfibtn.Setcheckbox(Value: boolean);
begin
fcheckbox := Value;
Paint;
end;

procedure TDelfibtn.SetCol(Value: TColor);
begin
Color_ := Value;
SetBmp(bmp);
Paint;
end;

procedure TDelfibtn.set_color_light(Value: TColor);
begin
_color_light := Value;
SetBmp(bmp);
Paint;
end;

procedure TDelfibtn.set_color_shadow(Value: TColor);
begin
_color_shadow := Value;
SetBmp(bmp);
Paint;
end;

procedure TDelfibtn.set_bordercolor(Value: TColor);
begin
fbordercolor := Value;
Paint;
end;

procedure TDelfibtn.SetCap(Value: string);
begin
if Caption_ = fcaption_down_ then fcaption_down_:=value;
Caption_ := value;
Paint;
end;

procedure TDelfibtn.SetCap_down_(Value: string);
begin
fcaption_down_ := value;
Paint;
end;

procedure TDelfibtn.Setroundededges(Value: boolean);
begin
froundededges := value;
Paint;
end;

procedure TDelfibtn.Setflat(Value: boolean);
begin
fflat := value;
Paint;
end;

procedure TDelfibtn.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var pos_,pos__:tpoint;
begin
inherited;
if Enab then begin
SetFocus;
focused___:=true;

if fcheckbox = true then begin
if (Button = mbLeft) and Enab then begin

GetCursorPos(pos__);
pos_ := ClientToScreen(Point(0, 0));
if Enab then if (Button = mbLeft) then if ptinrect(rect(Pos_.X,Pos_.Y,Pos_.X+width,Pos_.Y+height),pos__) then fdown := not fdown;
Paint;
end;
end;

if fcheckbox = false then begin
if (Button = mbLeft) and Enab then begin
GetCursorPos(pos__);
pos_ := ClientToScreen(Point(0, 0));
if Enab then if (Button = mbLeft) then if ptinrect(rect(Pos_.X,Pos_.Y,Pos_.X+width,Pos_.Y+height),pos__) then fdown:=true;
Paint;
end;
end;
end;
if assigned(OnMouseDown) then OnMouseDown(self,button,shift,x,y);
end;

procedure TDelfibtn.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var Pos, pos_, pos__:tpoint;
begin
inherited;
if Enab then begin
if fcheckbox = true then begin
if (Button = mbLeft) and Enab then begin
//fdown := not fdown;
Paint;
end;
end;

if fcheckbox = false then begin
if (Button = mbLeft) and Enab then begin

GetCursorPos(pos__);
pos_ := ClientToScreen(Point(0, 0));
if Enab then if (Button = mbLeft) then fdown:=false;
Paint;
end;
end;

GetCursorPos(pos__);
pos_ := ClientToScreen(Point(0, 0));

if fcheckbox = true then if Enab then if (Button = mbLeft) then if Assigned(BtnClick) then BtnClick(Self);
if fcheckbox = false then if Enab then if (Button = mbLeft) then if ptinrect(rect(Pos_.X,Pos_.Y,Pos_.X+width,Pos_.Y+height),pos__) then if Assigned(BtnClick) then BtnClick(Self);

if Enab = true then pos := ClientToScreen(Point(0, Height));
if Enab = true then if fpopup_ <> nil then fpopup_.Popup(Pos.X,Pos.Y);

end;
if assigned(OnMouseup) then OnMouseup(self,button,shift,x,y);
end;

procedure TDelfibtn.KeyDown(var Key: Word; Shift: TShiftState);
begin
if Enab then begin
if spacedown = false then begin

If (Key = VK_SPACE) then begin

spacedown:=true;
if fcheckbox = true then begin
if Enab then begin
fdown := not fdown;
Paint;
end;
end;

if fcheckbox = false then begin
if Enab then begin
fdown:=true;
Paint;
end;
end;

end;
inherited keydown(key,shift);
end;
end;
If (Key = VK_RETURN) then if Enab then if Assigned(BtnClick) then BtnClick(Self);
If (Key = VK_RETURN) then begin
application.ProcessMessages;
if Enab then pos := ClientToScreen(Point(0, Height));
if Enab = true then if fpopup_ <> nil then fpopup_.Popup(Pos.X,Pos.Y);
end;
end;

procedure TDelfibtn.KeyUp(var Key: Word; Shift: TShiftState);
begin
inherited keyup(key,shift);
if Enab then begin
If (Key = VK_SPACE) then begin
if fcheckbox = false then begin
fdown := false;
end;
spacedown:=false;
if Enab then if Assigned(BtnClick) then BtnClick(Self);

application.ProcessMessages;
if Enab then pos := ClientToScreen(Point(0, Height));
if Enab = true then if fpopup_ <> nil then fpopup_.Popup(Pos.X,Pos.Y);

end;
Paint;
//inherited keyup(key,shift);
end;
end;

procedure TDelfibtn.CMExit(var Message:TCMExit);
begin
repaint;
inherited;
end;

procedure TDelfibtn.KeyPress(var Key: char);
begin
inherited keypress(key);
//repaint;
end;

procedure TDelfibtn.CMEnter(var message:TCMGotFocus);
begin
inherited;
repaint;
end;

procedure TDelfibtn.WMSETFOCUS (var message: TMessage);
begin
Focused___ := true;
repaint;
end;

procedure TDelfibtn.WMKILLFOCUS (var message: TMessage);
begin
Focused___ := false;
repaint;
end;

procedure Register;
begin
RegisterComponents('Delfi', [tDelfibtn]);
end;

end.
